/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package adresar;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Formatter;
import java.util.NoSuchElementException;
import java.util.Scanner;

/**
 *
 * @author petr
 */
public class WriteAdresar {

    /**
     * Objekt sloužící pro výstup formátovaného textu do souboru.
     */
    private Formatter output;

    /**
     * Otevře soubor se záznamy.
     */
    public void openFile(String fileName) throws SecurityException, FileNotFoundException {
        File f = new File(fileName);
        if(f.exists()) {
            f.renameTo(new File(fileName+"~"));
        }
        output = new Formatter(f);
    }

    /**
     * Zavře souborový proud
     */
    public void closeFile() {
        if (output != null) {
            output.close();
        }
    }

    public static Adresar nactiAdrearOdUzivatele() {
        Adresar adr = new Adresar();
        try {
            Scanner input = new Scanner(System.in);
            System.out.print("Zadejte křestní jméno: ");
            adr.setFirstName(input.nextLine());
            System.out.print("Zadejte příjmení: ");
            adr.setLastName(input.nextLine());
            System.out.print("Zadejte ulici: ");
            adr.setStreet(input.nextLine());
            System.out.print("Zadejte čp: ");
            adr.setCisloPopisne(input.nextLine());
            System.out.print("Zadejte město: ");
            adr.setCity(input.nextLine());
            System.out.print("Zadejte PSČ: ");
            adr.setPSC(input.nextLine());
            System.out.print("Zadejte telefon: ");
            adr.setPhone(input.nextLine());
        } catch (NoSuchElementException e) {
            System.err.print("Nelze načíst položku");
            return null;
        }
        return adr;
    }

    private void writeAdresar(Adresar adr) {
        if (adr == null) {
            return;
        }
        String[] attrs = adr.getAttributesAsStrings();
        for (String s : attrs) {
            output.format("%s%n", s);
        }
    }

    /**
     * Nechá si zadat záznamy od uživatele a uloží je do souboru.
     */
    public void addRecords() {
       Adresar adr = null;
       while (true) {
            try {
                adr = null;
                boolean pokracovat = false;
                String tmp;
                while (true) {
                    Scanner input = new Scanner(System.in);
                    System.out.print("Chcete přidat další záznam? [y/n]: ");
                    tmp = input.nextLine();
                    if (tmp.equals("y") || tmp.equals("Y")) {
                        pokracovat = true;
                        break;
                    }
                    if (tmp.equals("n") || tmp.equals("N")) {
                        break;
                    }
                }
                if (!pokracovat) {
                    break;
                }
                adr = WriteAdresar.nactiAdrearOdUzivatele();
                writeAdresar(adr);
            } catch (NoSuchElementException e) {
                System.err.println(e);
            }
            if (adr == null) {
                return;
            }
        }
    }
}
